import java.util.*;

public class Screamers
{

    public static void main(String[] args)
    {
        Screamers a = new Screamers();
        Scanner s = new Scanner(System.in);
        int turns = s.nextInt();
        int m = s.nextInt(); // rows
        int n = s.nextInt(); // cols

        Tile grid[][] = new Tile[m][n];
        for (int i = 0; i < m; i++)
        {
            for (int j = 0; j < n; j++)
                grid[i][j] = new Tile();
        }
        List<Wolf> wolves = new ArrayList();
        List<Sheep> sheeps = new ArrayList();

        for (int i = 0; i < m; i++)
        {
            String lineS = s.next();
            char[] line = lineS.toCharArray();
            for (int j = 0; j < n; j++)
            {
                switch (line[j])
                {
                    case 'S':
                        Sheep sh = new Sheep(i,j);
                        sheeps.add(sh);
                        grid[i][j].sheep = sh;
                        break;
                    case 'W':
                        Wolf wo = new Wolf(i,j);
                        wolves.add(wo);
                        grid[i][j].wolf = wo;
                        break;
                }
            }
        }

        for (int i = 0; i < turns; i++)
        {
            for (Wolf wolf : wolves)
            {
                grid[wolf.row][wolf.col].wolf = null;
                int newi = wolf.move(n);
                //grid[wolf.row][newi].wolf = wolf;
            }
            for (Sheep sheep : sheeps)
            {
                grid[sheep.row][sheep.col].sheep = null;
                int newi = sheep.move(m);
                //grid[newi][sheep.col].sheep = sheep;
            }
            for (Wolf wolf : wolves)
            {
                grid[wolf.row][wolf.col].wolf = wolf;
                //grid[wolf.row][newi].wolf = wolf;
            }
            for (Sheep sheep : sheeps)
            {
                grid[sheep.row][sheep.col].sheep = sheep;
                //grid[newi][sheep.col].sheep = sheep;
            }
            for (Wolf wolf : wolves)
            {
                if (grid[wolf.row][wolf.col].sheep != null)
                {
                    Sheep sh = grid[wolf.row][wolf.col].sheep;
                    grid[wolf.row][wolf.col].sheep = null;
                    grid[wolf.row][wolf.col].state = 0;
                    wolf.eat();
                    for (Iterator it = sheeps.iterator(); it.hasNext();)
                    {
                        if (it.next() == sh)
                            it.remove();
                    }
                }
            }
            for (Sheep sheep : sheeps)
            {
                if (grid[sheep.row][sheep.col].state == 2)
                {
                    grid[sheep.row][sheep.col].state = 1;
                    grid[sheep.row][sheep.col].turns = 4;//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                    sheep.eat();
                }
            }
            for (Iterator it = wolves.iterator(); it.hasNext(); )
            {
                Wolf wolf = (Wolf) it.next();
                if (wolf.die())
                {
                    grid[wolf.row][wolf.col].wolf = null;
                    grid[wolf.row][wolf.col].state = 0;
                    it.remove();
                }
            }
            for (Iterator it = sheeps.iterator(); it.hasNext(); )
            {
                Sheep sheep = (Sheep) it.next();
                if (sheep.die())
                {
                    grid[sheep.row][sheep.col].sheep = null;
                    grid[sheep.row][sheep.col].state = 0;
                    it.remove();
                }
            }
            for (int j = 0; j < m; j++)
            {
                for (int k = 0; k < n; k++)
                {
                    grid[j][k].grow();
                }
            }
        }

        for (int i = 0; i < m; i++)
        {
            for (int j = 0; j < n; j++)
            {
                Tile t = grid[i][j];
                if (t.wolf != null)
                    System.out.print('W');
                else if (t.sheep != null)
                    System.out.print('S');
                else if (t.state == 0)
                    System.out.print('*');
                else if (t.state == 1)
                    System.out.print('.');
                else if (t.state == 2)
                    System.out.print('#');
            }
            System.out.println();
        }
    }
}

class Tile
{
    int state = 1; //0 dead 1 empty 2 grass
    int turns = 3; //turns to grow
    Wolf wolf = null;
    Sheep sheep = null;

    void grow()
    {
        if (state == 1)
        {
            turns--;
            if (turns == 0)
                state = 2;
        }
    }
}

class Wolf
{
    int row,col;
    int turns = 10;
    Wolf(int row, int col)
    {
        this.row = row;
        this.col = col;
    }

    int move (int n)
    {
        col++;
        if (col >= n)
            col = 0;
        return col;
    }

    void eat()
    {
        turns = 11;
    }

    boolean die()
    {
        turns--;
        return turns == 0;
    }
}

class Sheep
{
    int row,col;
    int turns = 5;
    Sheep(int row, int col)
    {
        this.row = row;
        this.col = col;
    }

    int move(int n)
    {
        row++;
        if (row >= n)
            row = 0;
        return row;
    }

    void eat()
    {
        turns = 6;
    }

    boolean die()
    {
        turns--;
        return turns == 0;
    }
}